#pragma once
#ifndef SERVER_COMMON_ROUND_TRIP_TIMES_INCLUDED__
#define SERVER_COMMON_ROUND_TRIP_TIMES_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: RoundTripTimes.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2010 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "RoundTripTime.h"

#include <vector>

///////////////////////////////////////////////////////////////////////////////
// CRoundTripTimes
///////////////////////////////////////////////////////////////////////////////

class CRoundTripTimes
{
   private :

      typedef std::vector<CRoundTripTime> Times;

   public :

      CRoundTripTimes();

      CRoundTripTimes(
         const CRoundTripTimes &rhs) = delete;

      CRoundTripTimes &operator=(
         const CRoundTripTimes &rhs) = delete;

      void SetNumberOfTimes(
         size_t numberOfTimes);

      void MarkAsSent(
         size_t index);

      void MarkAsReceived(
         size_t index);

      size_t GetNumSent() const;

      size_t GetNumReceived() const;

      DWORD GetAverageRTT() const;

      DWORD GetMaxRTT() const;

      DWORD GetMinRTT() const;

      typedef Times::const_iterator Iterator;

      Iterator Begin() const;

      Iterator End() const;

   private :

      Times m_times;
};

#endif // SERVER_COMMON_ROUND_TRIP_TIMES_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: RoundTripTimes.h
///////////////////////////////////////////////////////////////////////////////
