#pragma once
#ifndef SERVER_COMMON_STREAM_SOCKET_SERVER_EX_CALLBACK_INCLUDED__
#define SERVER_COMMON_STREAM_SOCKET_SERVER_EX_CALLBACK_INCLUDED__
///////////////////////////////////////////////////////////////////////////////
// File: StreamSocketServerExCallback.h
///////////////////////////////////////////////////////////////////////////////
//
// Copyright 2007 JetByte Limited.
//
// This software is provided "as is" without a warranty of any kind. All
// express or implied conditions, representations and warranties, including
// any implied warranty of merchantability, fitness for a particular purpose
// or non-infringement, are hereby excluded. JetByte Limited and its licensors
// shall not be liable for any damages suffered by licensee as a result of
// using the software. In no event will JetByte Limited be liable for any
// lost revenue, profit or data, or for direct, indirect, special,
// consequential, incidental or punitive damages, however caused and regardless
// of the theory of liability, arising out of the use of or inability to use
// software, even if JetByte Limited has been advised of the possibility of
// such damages.
//
///////////////////////////////////////////////////////////////////////////////

#include "JetByteTools/SocketTools/IStreamSocketServerExCallback.h"

///////////////////////////////////////////////////////////////////////////////
// CStreamSocketServerExCallback
///////////////////////////////////////////////////////////////////////////////

class CStreamSocketServerExCallback: public JetByteTools::Socket::IStreamSocketServerExCallback
{
   public :

      // Implement JetByteTools::Socket::IStreamSocketServerExCallback

      void OnIncrementPendingReceives(
         DWORD pendingReceives) override;

      void OnDecrementPendingReceives(
         DWORD pendingReceives) override;

      // Implement JetByteTools::Socket::IStreamSocketServerCallback

      void OnStartAcceptingConnections() override;

      void OnStopAcceptingConnections() override;

      void OnAcceptError(
         DWORD lastError) override;

      // Implement JetByteTools::Socket::IStreamSocketConnectionManagerCallback

      void OnSocketCreated(
         SOCKET s) override;

      void OnPreOutgoingConnect(
         JetByteTools::Core::IIndexedOpaqueUserData &userData,
         const JetByteTools::Socket::IAddress &address,
         const void *pUserData) override;

      void OnConnectionEstablished(
         JetByteTools::Socket::IStreamSocket &socket,
         const JetByteTools::Socket::IAddress &address) override;

      void OnOutgoingConnectionFailed(
         JetByteTools::Socket::IStreamSocket &socket,
         const JetByteTools::Socket::IAddress &address,
         DWORD lastError) override;

      void OnSocketReleased(
         JetByteTools::Core::IIndexedOpaqueUserData &userData) override;

      void OnReadCompleted(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnReadCompletionError(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnReadOOBCompleted(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnWriteCompleted(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer) override;

      void OnWriteCompletionError(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::IO::CSmartBuffer &buffer,
         DWORD lastError) override;

      void OnMaximumConnections() override;

      void OnAllConnectionsAborted(
         DWORD numberOfConnectionsAborted) override;

      void OnShutdownInitiated() override;

      void OnShutdownComplete() override;

      // Implement JetByteTools::Socket::IStreamSocketCallback

      void OnConnectionClientClose(
          JetByteTools::Socket::IStreamSocket &socket) override;

      void OnConnectionReset(
          JetByteTools::Socket::IStreamSocket &socket,
          DWORD lastError) override;

      void OnConnectionClosure(
         JetByteTools::Socket::IStreamSocket &socket,
         JetByteTools::Socket::ConnectionClosureReason reason) override;

      void OnConnectionClosed(
         JetByteTools::Socket::IStreamSocket &socket) override;

      // Implement ISocketCallback

      void OnError(
         const JetByteTools::Core::_tstring &message) override;

      void OnError(
         const JetByteTools::Core::_tstring &message,
         DWORD lastError) override;
};

#endif // SERVER_COMMON_STREAM_SOCKET_SERVER_EX_CALLBACK_INCLUDED__

///////////////////////////////////////////////////////////////////////////////
// End of file: StreamSocketServerExCallback.h
///////////////////////////////////////////////////////////////////////////////

